%Phaedra Sep 21, 2007
%
% A_new=A_old+H(A_old)^-1*g(A_old)
%
% Input: A_old = 1*K old alpha 
%        GG = G*K current gamma matrix
%
% Output: A_new = updated alpha
%
% Other pgms: none
%
% A_new=alpha_update(A,GG);

function A_new=alpha_update(A,GG)

[D,K]=size(GG);
[t,K1]=size(A);
if K1~=K
    error('dimensions of A and G should match')
end

GGbar=sum(GG,2);

%alpha_small=1e-3;
%A(find(A<0))=alpha_small;
Abar=sum(A); 

%finding grad = deriv wrt A, updated Oct 2 2007
grad=D*(repmat(psi(Abar),1,K)-psi(A));
temp=psi(GG)-repmat(psi(GGbar),1,K);
grad=grad+sum(temp,1);

%finding H=Hessian
%Alternate method insead of inv implemented at (***) (inv is expensive)
% With reference to A.1 in 'The Latent Process Decomposition of cDNA
% Microarray Datasets [1]', and A.2 in 'Latent Dirichlet Allocation', 
% by David Blei et al [2]
% here is the update without inverting Hessian:
h = -D * psi(1,A);
z = D*psi(1,Abar);
%Hessian_mat = diag(h) + ones(K)*z;

c=sum(grad./h);
c_denom=(z.^-1)+sum(h.^-1);
c=c/c_denom;
invHg=(grad-c)./h;
A_new=A-invHg;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%long way using inv - checked: it corresponds with the above to 10^-16
%Hessian_mat = -G * diag(psi(1,A)) + G * ones(K)*psi(1,Abar);
%A_new2=[A'-(inv(Hessian_mat)*grad')]';
%max(abs(A_new-A_new2))
%if max(abs(A_new-A_new2))>0
%    error('error in A calculation')
%end